package form.data;

import form.*;
import form.io.*;
import form.comp.*;
import java.lang.*;
import java.util.*;

public class PasswordData{

	private PasswordPanel[] pwpanels = null;

	public PasswordPanel[] makePanels(){
		String[] curr = null;
		int passcount = ht.size();
		pwpanels = new PasswordPanel[passcount];
		Enumeration e = ht.elements();

		for (int i =0; i < passcount; i++){
			curr = ((String[])e.nextElement());
			pwpanels[i]= new PasswordPanel(curr);
		}
		return pwpanels;
	}

	private Hashtable ht = new Hashtable();

	private final static String passName = "pass";
	public static int numArgs = 5;

	public PasswordData(){}

	public void add(String[] pass){
	    if (pass[0] != null)
	    ht.put(pass[0],pass);
	}

	public String[] remove(String pass){
		return ((String[])ht.remove(pass));
	}

	public String[] get(String pass){
		return ((String[])ht.get(pass));
	}

	public String passwordList(){
		String[] curr = null;
		String retVal = "";
		Enumeration e = ht.elements();
		while (e.hasMoreElements()){
			curr = ((String[])e.nextElement());
			retVal +=curr[0]+" "+curr[1]+"\n";
		}
		return retVal;
	}

	public Enumeration getPasswords(){
		return  ht.elements();
	}

	public void open(Open open){
		int count = 0;
		String[] curr = null;
		String nextLine = "";
		while (nextLine != null) {
			curr = new String[numArgs];
			for (int i = 0;i<numArgs; i++){
				nextLine = open.getParameter(passName+count+"."+i);
				curr[i] = nextLine;
			}
			count++;
			add(curr);
		}
	}

	public void save(ToHtml save){
		String[] curr = null;
		Enumeration e = ht.elements();
		int count = 0;
		while (e.hasMoreElements()){
			curr = ((String[])e.nextElement());
			for (int i = 0; i < curr.length; i++){
				save.add(passName+count+"."+i,curr[i]);
			}
			count++;
		}
	}

}
