package form.data;

import form.io.*;
import form.*;
import java.lang.*;




public class PropertyData {


    private String codebase = "/npib";
    private String name = "";
    private String title = "Npib form";
    private String cgiLocation = "/cgi-bin/npib.cgi";
    private String width = "600";
    private String height = "800";
    private String code = "form.FormLoader";
    private String archive = "form.jar";

    public static String[] getNames(){

	int i = 0;
	String[] name = new String[11];
	name[i++] = "codebase";
	name[i++] = "name";
	name[i++] = "title";
	name[i++] = "cgiLocation";
	name[i++] = "width";
	name[i++] = "height";
	name[i++] = "code";
	name[i++] = "archive"; 
        return name;
    }


    public PropertyData(){}

    public void save(ToHtml save){
	save.add("codebase",codebase); 
	save.add("name",name); 
	save.add("title",title); 
	save.add("cgiLocation",cgiLocation); 
	save.add("width",width); 
	save.add("height",height); 
	save.add("code",code); 
	save.add("archive",archive); 
    }

    public void open(Open open){
	codebase = open.getParameter("codebase");
	name = open.getParameter("name");
	title = open.getParameter("title");
	cgiLocation = open.getParameter("cgiLocation");
	width = open.getParameter("width");
	height = open.getParameter("height");
	code = open.getParameter("code");
	//archive = open.getParameter("archive"); 

    }

    public String getCodebase(){
	return codebase;
    }

    public String getName(){
	return name;
    }

    public String getTitle(){
	return title;
    }

    public String getCgiLocation(){
	return cgiLocation;
    }

    public String getWidth(){
	return width;
    }

    public String getHeight(){
	return height;
    }

    public String getCode(){
	return code;
    }

    public String getArchive(){
	return archive;
    }

    public void setCodebase(String str){
	codebase =str;
    }

    public void setName(String str){
	name =str;
    }

    public void setTitle(String str){
	title =str;
    }

    public void setCgiLocation(String str){
	cgiLocation =str;
    }

    public void setHeight(String str){
	height =str;
    }

    public void setWidth(String str){
	width =str;
    }

    public void setCode(String str){
	code =str;
    }

    public void setArchive(String str){
	archive =str;
    }


}
